/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.check.error;

import java.util.Optional;

import de.hft.stuttgart.citydoctor2.check.CheckError;
import de.hft.stuttgart.citydoctor2.check.ErrorId;
import de.hft.stuttgart.citydoctor2.check.ErrorReport;
import de.hft.stuttgart.citydoctor2.check.ErrorType;
import de.hft.stuttgart.citydoctor2.check.ErrorVisitor;
import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.check.ModificationListener;
import de.hft.stuttgart.citydoctor2.datastructure.GmlElement;
import de.hft.stuttgart.citydoctor2.datastructure.LinearRing;
import de.hft.stuttgart.citydoctor2.datastructure.Polygon;
import de.hft.stuttgart.citydoctor2.utils.SerializablePair;
import de.hft.stuttgart.quality.model.IntersectingRings;
import de.hft.stuttgart.quality.model.ValidationError;

/**
 * If the exterior ring and interior rings are intersecting each other, it
 * results in a polygon self intersection and this error is created.
 * 
 * @author Matthias Betz
 *
 */
public class PolygonIntersectingRingsError implements CheckError {

	private static final long serialVersionUID = -7043521697085991901L;
	
	private Polygon p;
	private SerializablePair<LinearRing, LinearRing> intersectingRings;

	public PolygonIntersectingRingsError(Polygon p, SerializablePair<LinearRing, LinearRing> intersectingRings) {
		this.p = p;
		this.intersectingRings = intersectingRings;
	}

	public Polygon getPolygon() {
		return p;
	}

	public SerializablePair<LinearRing, LinearRing> getIntersectingRings() {
		return intersectingRings;
	}

	@Override
	public void report(ErrorReport report) {
		report.add(p);
		report.add(intersectingRings.getValue0());
		report.add(intersectingRings.getValue1());
	}

	@Override
	public void accept(ErrorVisitor errorVisitor) {
		errorVisitor.visit(this);
	}

	@Override
	public boolean accept(HealingMethod method, ModificationListener l) {
		return method.visit(this, l);
	}

	@Override
	public String toString() {
		return "PolygonSelfIntError [p=" + p + ", intersectingRings=" + intersectingRings + "]";
	}

	@Override
	public ErrorType getType() {
		return ErrorType.ERROR;
	}

	@Override
	public ErrorId getErrorId() {
		return ErrorId.GE_P_INTERSECTING_RINGS;
	}

	@Override
	public GmlElement getFeature() {
		return getPolygon();
	}

	@Override
	public Optional<ValidationError> convertToQualityAdeDatastructure() {
		IntersectingRings err = new IntersectingRings();
		err.setPolygonId(p.getGmlId().getGmlString());
		err.setLinearRingId1(intersectingRings.getValue0().getGmlId().getGmlString());
		err.setLinearRingId2(intersectingRings.getValue1().getGmlId().getGmlString());
		return Optional.of(err);
	}
}
